package io.dekorate.component.adapter;

import java.nio.file.Path;
import java.util.stream.Collectors;
import io.dekorate.component.config.ComponentConfigBuilder;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Comparator;
import io.dekorate.project.Project;
import io.dekorate.component.config.ComponentConfig;
import io.dekorate.project.BuildInfo;
import io.dekorate.component.annotation.ComponentApplication;
import io.dekorate.component.model.DeploymentMode;
import io.dekorate.project.ScmInfo;
import java.util.Arrays;
import java.util.Map;

public class ComponentConfigAdapter{



    public static ComponentConfig adapt(ComponentApplication instance){
            return newBuilder(instance).build();
    }

    public static ComponentConfigBuilder newBuilder(ComponentApplication instance){
            return new ComponentConfigBuilder(new io.dekorate.component.config.ComponentConfig(null,
            null,
            instance.name(),
            instance.deploymentMode(),
            instance.exposeService(),
            Arrays.asList(instance.envs()).stream().map(i ->new io.dekorate.kubernetes.config.Env(i.name(),
            i.value(),
            i.secret(),
            i.configmap(),
            i.field())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Env[0]),
            instance.buildType()));
    }

    public static ComponentConfig adapt(Map map){
            return new io.dekorate.component.config.ComponentConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               DeploymentMode.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("deploymentMode","dev") : "dev")),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("exposeService","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("buildType", "s2i") : "s2i"));
    }

    public static ComponentConfigBuilder newBuilder(Map map){
            return new ComponentConfigBuilder(new io.dekorate.component.config.ComponentConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               DeploymentMode.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("deploymentMode","dev") : "dev")),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("exposeService","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("buildType", "s2i") : "s2i")));
    }




}
