package io.dekorate.component.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import java.lang.Object;
import java.lang.String;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@io.sundr.builder.annotations.Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class CapabilityConfig extends Configuration{

    private String category;
    private String kind;
    private String name;
    private String version = "";
    private io.dekorate.component.config.Parameter[] parameters = new io.dekorate.component.config.Parameter[0];

    public CapabilityConfig(){
    }
    public CapabilityConfig(Project project,Map<ConfigKey,Object> attributes,String category,String kind,String name,String version,io.dekorate.component.config.Parameter[] parameters){
            super(project, attributes);
            this.category = category;
            this.kind = kind;
            this.name = name;
            this.version = version != null ? version : "";
            this.parameters = parameters != null ? parameters : new io.dekorate.component.config.Parameter[0];
    }

    public String getCategory(){
            return this.category;
    }

    public String getKind(){
            return this.kind;
    }

    public String getName(){
            return this.name;
    }

    public String getVersion(){
            return this.version;
    }

    public io.dekorate.component.config.Parameter[] getParameters(){
            return this.parameters;
    }

    public static CapabilityConfigBuilder newCapabilityConfigBuilder(){
            return new io.dekorate.component.config.CapabilityConfigBuilder();
    }




}
