package io.dekorate.component.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigKey;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public interface CapabilityConfigFluent<A extends CapabilityConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getCategory();
    public A withCategory(String category);
    public Boolean hasCategory();
    public A withNewCategory(String arg1);
    public A withNewCategory(StringBuilder arg1);
    public A withNewCategory(StringBuffer arg1);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    public A withParameters(io.dekorate.component.config.Parameter... parameters);
    
/**
 * This method has been deprecated, please use method buildParameters instead.
 */
@Deprecated public io.dekorate.component.config.Parameter[] getParameters();
    public io.dekorate.component.config.Parameter[] buildParameters();
    public io.dekorate.component.config.Parameter buildParameter(int index);
    public io.dekorate.component.config.Parameter buildFirstParameter();
    public io.dekorate.component.config.Parameter buildLastParameter();
    public io.dekorate.component.config.Parameter buildMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate);
    public Boolean hasMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate);
    public A addToParameters(int index,io.dekorate.component.config.Parameter item);
    public A setToParameters(int index,io.dekorate.component.config.Parameter item);
    public A addToParameters(io.dekorate.component.config.Parameter... items);
    public A addAllToParameters(Collection<io.dekorate.component.config.Parameter> items);
    public A removeFromParameters(io.dekorate.component.config.Parameter... items);
    public A removeAllFromParameters(Collection<io.dekorate.component.config.Parameter> items);
    public A removeMatchingFromParameters(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate);
    public Boolean hasParameters();
    public A addNewParameter(String name,String value);
    public CapabilityConfigFluent.ParametersNested<A> addNewParameter();
    public CapabilityConfigFluent.ParametersNested<A> addNewParameterLike(io.dekorate.component.config.Parameter item);
    public CapabilityConfigFluent.ParametersNested<A> setNewParameterLike(int index,io.dekorate.component.config.Parameter item);
    public CapabilityConfigFluent.ParametersNested<A> editParameter(int index);
    public CapabilityConfigFluent.ParametersNested<A> editFirstParameter();
    public CapabilityConfigFluent.ParametersNested<A> editLastParameter();
    public CapabilityConfigFluent.ParametersNested<A> editMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate);

    public interface ParametersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,io.dekorate.component.config.ParameterFluent<CapabilityConfigFluent.ParametersNested<N>>{

        
    public N and();    public N endParameter();
}


}
