package io.dekorate.component.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigurationFluentImpl;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

public class CapabilityConfigFluentImpl<A extends CapabilityConfigFluent<A>> extends ConfigurationFluentImpl<A> implements CapabilityConfigFluent<A>{

    private String category;
    private String kind;
    private String name;
    private String version = "";
    private List<io.dekorate.component.config.ParameterBuilder> parameters =  new ArrayList<io.dekorate.component.config.ParameterBuilder>();

    public CapabilityConfigFluentImpl(){
    }
    public CapabilityConfigFluentImpl(CapabilityConfig instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withCategory(instance.getCategory()); 
            this.withKind(instance.getKind()); 
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.withParameters(instance.getParameters()); 
    }

    public String getCategory(){
            return this.category;
    }

    public A withCategory(String category){
            this.category=category; return (A) this;
    }

    public Boolean hasCategory(){
            return this.category != null;
    }

    public A withNewCategory(String arg1){
            return (A)withCategory(new String(arg1));
    }

    public A withNewCategory(StringBuilder arg1){
            return (A)withCategory(new String(arg1));
    }

    public A withNewCategory(StringBuffer arg1){
            return (A)withCategory(new String(arg1));
    }

    public String getKind(){
            return this.kind;
    }

    public A withKind(String kind){
            this.kind=kind; return (A) this;
    }

    public Boolean hasKind(){
            return this.kind != null;
    }

    public A withNewKind(String arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuilder arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuffer arg1){
            return (A)withKind(new String(arg1));
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getVersion(){
            return this.version;
    }

    public A withVersion(String version){
            this.version=version; return (A) this;
    }

    public Boolean hasVersion(){
            return this.version != null;
    }

    public A withNewVersion(String arg1){
            return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuilder arg1){
            return (A)withVersion(new String(arg1));
    }

    public A withNewVersion(StringBuffer arg1){
            return (A)withVersion(new String(arg1));
    }

    public A withParameters(io.dekorate.component.config.Parameter... parameters){
            if (this.parameters != null) {this.parameters.clear();}
            if (parameters != null) {for (io.dekorate.component.config.Parameter item :parameters){ this.addToParameters(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildParameters instead.
 */
@Deprecated public io.dekorate.component.config.Parameter[] getParameters(){
            int size = parameters != null ? parameters.size() : 0;
io.dekorate.component.config.Parameter[] result = new io.dekorate.component.config.Parameter[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.component.config.Parameter,?> builder : parameters) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.component.config.Parameter[] buildParameters(){
            int size = parameters != null ? parameters.size() : 0;
io.dekorate.component.config.Parameter[] result = new io.dekorate.component.config.Parameter[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.component.config.Parameter,?> builder : parameters) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.component.config.Parameter buildParameter(int index){
            return this.parameters.get(index).build();
    }

    public io.dekorate.component.config.Parameter buildFirstParameter(){
            return this.parameters.get(0).build();
    }

    public io.dekorate.component.config.Parameter buildLastParameter(){
            return this.parameters.get(parameters.size() - 1).build();
    }

    public io.dekorate.component.config.Parameter buildMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate){
            for (io.dekorate.component.config.ParameterBuilder item: parameters) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate){
            for (io.dekorate.component.config.ParameterBuilder item: parameters) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToParameters(int index,io.dekorate.component.config.Parameter item){
            if (this.parameters == null) {this.parameters = new ArrayList<io.dekorate.component.config.ParameterBuilder>();}
            io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);_visitables.get("parameters").add(index >= 0 ? index : _visitables.get("parameters").size(), builder);this.parameters.add(index >= 0 ? index : parameters.size(), builder); return (A)this;
    }

    public A setToParameters(int index,io.dekorate.component.config.Parameter item){
            if (this.parameters == null) {this.parameters = new ArrayList<io.dekorate.component.config.ParameterBuilder>();}
            io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);
            if (index < 0 || index >= _visitables.get("parameters").size()) { _visitables.get("parameters").add(builder); } else { _visitables.get("parameters").set(index, builder);}
            if (index < 0 || index >= parameters.size()) { parameters.add(builder); } else { parameters.set(index, builder);}
             return (A)this;
    }

    public A addToParameters(io.dekorate.component.config.Parameter... items){
            if (this.parameters == null) {this.parameters = new ArrayList<io.dekorate.component.config.ParameterBuilder>();}
            for (io.dekorate.component.config.Parameter item : items) {io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);_visitables.get("parameters").add(builder);this.parameters.add(builder);} return (A)this;
    }

    public A addAllToParameters(Collection<io.dekorate.component.config.Parameter> items){
            if (this.parameters == null) {this.parameters = new ArrayList<io.dekorate.component.config.ParameterBuilder>();}
            for (io.dekorate.component.config.Parameter item : items) {io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);_visitables.get("parameters").add(builder);this.parameters.add(builder);} return (A)this;
    }

    public A removeFromParameters(io.dekorate.component.config.Parameter... items){
            for (io.dekorate.component.config.Parameter item : items) {io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);_visitables.get("parameters").remove(builder);if (this.parameters != null) {this.parameters.remove(builder);}} return (A)this;
    }

    public A removeAllFromParameters(Collection<io.dekorate.component.config.Parameter> items){
            for (io.dekorate.component.config.Parameter item : items) {io.dekorate.component.config.ParameterBuilder builder = new io.dekorate.component.config.ParameterBuilder(item);_visitables.get("parameters").remove(builder);if (this.parameters != null) {this.parameters.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromParameters(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate){
            if (parameters == null) return (A) this;
            final Iterator<io.dekorate.component.config.ParameterBuilder> each = parameters.iterator();
            final List visitables = _visitables.get("parameters");
            while (each.hasNext()) {
              io.dekorate.component.config.ParameterBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasParameters(){
            return parameters != null && !parameters.isEmpty();
    }

    public A addNewParameter(String name,String value){
            return (A)addToParameters(new Parameter(name, value));
    }

    public CapabilityConfigFluent.ParametersNested<A> addNewParameter(){
            return new ParametersNestedImpl();
    }

    public CapabilityConfigFluent.ParametersNested<A> addNewParameterLike(io.dekorate.component.config.Parameter item){
            return new ParametersNestedImpl(-1, item);
    }

    public CapabilityConfigFluent.ParametersNested<A> setNewParameterLike(int index,io.dekorate.component.config.Parameter item){
            return new ParametersNestedImpl(index, item);
    }

    public CapabilityConfigFluent.ParametersNested<A> editParameter(int index){
            if (parameters.size() <= index) throw new RuntimeException("Can't edit parameters. Index exceeds size.");
            return setNewParameterLike(index, buildParameter(index));
    }

    public CapabilityConfigFluent.ParametersNested<A> editFirstParameter(){
            if (parameters.size() == 0) throw new RuntimeException("Can't edit first parameters. The list is empty.");
            return setNewParameterLike(0, buildParameter(0));
    }

    public CapabilityConfigFluent.ParametersNested<A> editLastParameter(){
            int index = parameters.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last parameters. The list is empty.");
            return setNewParameterLike(index, buildParameter(index));
    }

    public CapabilityConfigFluent.ParametersNested<A> editMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.component.config.ParameterBuilder> predicate){
            int index = -1;
            for (int i=0;i<parameters.size();i++) { 
            if (predicate.apply(parameters.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching parameters. No match found.");
            return setNewParameterLike(index, buildParameter(index));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilityConfigFluentImpl that = (CapabilityConfigFluentImpl) o;
            if (category != null ? !category.equals(that.category) :that.category != null) return false;
            if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (version != null ? !version.equals(that.version) :that.version != null) return false;
            if (parameters != null ? !parameters.equals(that.parameters) :that.parameters != null) return false;
            return true;
    }


    public class ParametersNestedImpl<N> extends io.dekorate.component.config.ParameterFluentImpl<CapabilityConfigFluent.ParametersNested<N>> implements CapabilityConfigFluent.ParametersNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final io.dekorate.component.config.ParameterBuilder builder;
        private final int index;
    
            ParametersNestedImpl(int index,io.dekorate.component.config.Parameter item){
                    this.index = index;
                    this.builder = new io.dekorate.component.config.ParameterBuilder(this, item);
            }
            ParametersNestedImpl(){
                    this.index = -1;
                    this.builder = new io.dekorate.component.config.ParameterBuilder(this);
            }
    
    public N and(){
            return (N) CapabilityConfigFluentImpl.this.setToParameters(index, builder.build());
    }
    public N endParameter(){
            return and();
    }

}


}
