package io.dekorate.component.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import io.dekorate.component.model.Kind;
import java.lang.Object;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@io.sundr.builder.annotations.Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class LinkConfig extends Configuration{

    private String name = "";
    private String componentName;
    private Kind kind = io.dekorate.component.model.Kind.Env;
    private String ref = "";
    private io.dekorate.kubernetes.config.Env[] envs = new io.dekorate.kubernetes.config.Env[0];

    public LinkConfig(){
    }
    public LinkConfig(Project project,Map<ConfigKey,Object> attributes,String name,String componentName,Kind kind,String ref,io.dekorate.kubernetes.config.Env[] envs){
            super(project, attributes);
            this.name = name != null ? name : "";
            this.componentName = componentName;
            this.kind = kind != null ? kind : io.dekorate.component.model.Kind.Env;
            this.ref = ref != null ? ref : "";
            this.envs = envs != null ? envs : new io.dekorate.kubernetes.config.Env[0];
    }

    public String getName(){
            return this.name;
    }

    public String getComponentName(){
            return this.componentName;
    }

    public Kind getKind(){
            return this.kind;
    }

    public String getRef(){
            return this.ref;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvs(){
            return this.envs;
    }

    public static LinkConfigBuilder newLinkConfigBuilder(){
            return new io.dekorate.component.config.LinkConfigBuilder();
    }




}
