package io.dekorate.component.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class CapabilityBuilder extends io.dekorate.component.model.CapabilityFluentImpl<io.dekorate.component.model.CapabilityBuilder> implements VisitableBuilder<io.dekorate.component.model.Capability,io.dekorate.component.model.CapabilityBuilder>{

    io.dekorate.component.model.CapabilityFluent<?> fluent;
    Boolean validationEnabled;

    public CapabilityBuilder(){
            this(true);
    }
    public CapabilityBuilder(Boolean validationEnabled){
            this(new Capability(), validationEnabled);
    }
    public CapabilityBuilder(io.dekorate.component.model.CapabilityFluent<?> fluent){
            this(fluent, true);
    }
    public CapabilityBuilder(io.dekorate.component.model.CapabilityFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Capability(), validationEnabled);
    }
    public CapabilityBuilder(io.dekorate.component.model.CapabilityFluent<?> fluent,io.dekorate.component.model.Capability instance){
            this(fluent, instance, true);
    }
    public CapabilityBuilder(io.dekorate.component.model.CapabilityFluent<?> fluent,io.dekorate.component.model.Capability instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            fluent.withSpec(instance.getSpec()); 
            fluent.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }
    public CapabilityBuilder(io.dekorate.component.model.Capability instance){
            this(instance,true);
    }
    public CapabilityBuilder(io.dekorate.component.model.Capability instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.component.model.Capability build(){
            Capability buildable = new Capability(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilityBuilder that = (CapabilityBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
