package io.dekorate.component.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Boolean;

public interface CapabilitySpecFluent<A extends CapabilitySpecFluent<A>> extends Fluent<A>{


    public String getCategory();
    public A withCategory(String category);
    public Boolean hasCategory();
    public A withNewCategory(String arg1);
    public A withNewCategory(StringBuilder arg1);
    public A withNewCategory(StringBuffer arg1);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    public A withParameters(io.dekorate.component.model.Parameter... parameters);
    
/**
 * This method has been deprecated, please use method buildParameters instead.
 */
@Deprecated public io.dekorate.component.model.Parameter[] getParameters();
    public io.dekorate.component.model.Parameter[] buildParameters();
    public io.dekorate.component.model.Parameter buildParameter(int index);
    public io.dekorate.component.model.Parameter buildFirstParameter();
    public io.dekorate.component.model.Parameter buildLastParameter();
    public io.dekorate.component.model.Parameter buildMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public Boolean hasMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public A addToParameters(int index,io.dekorate.component.model.Parameter item);
    public A setToParameters(int index,io.dekorate.component.model.Parameter item);
    public A addToParameters(io.dekorate.component.model.Parameter... items);
    public A addAllToParameters(Collection<io.dekorate.component.model.Parameter> items);
    public A removeFromParameters(io.dekorate.component.model.Parameter... items);
    public A removeAllFromParameters(Collection<io.dekorate.component.model.Parameter> items);
    public A removeMatchingFromParameters(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public Boolean hasParameters();
    public A addNewParameter(String name,String value);
    public CapabilitySpecFluent.ParametersNested<A> addNewParameter();
    public CapabilitySpecFluent.ParametersNested<A> addNewParameterLike(io.dekorate.component.model.Parameter item);
    public CapabilitySpecFluent.ParametersNested<A> setNewParameterLike(int index,io.dekorate.component.model.Parameter item);
    public CapabilitySpecFluent.ParametersNested<A> editParameter(int index);
    public CapabilitySpecFluent.ParametersNested<A> editFirstParameter();
    public CapabilitySpecFluent.ParametersNested<A> editLastParameter();
    public CapabilitySpecFluent.ParametersNested<A> editMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public String getParametersJson();
    public A withParametersJson(String parametersJson);
    public Boolean hasParametersJson();
    public A withNewParametersJson(String arg1);
    public A withNewParametersJson(StringBuilder arg1);
    public A withNewParametersJson(StringBuffer arg1);

    public interface ParametersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ParameterFluent<CapabilitySpecFluent.ParametersNested<N>>{

        
    public N and();    public N endParameter();
}


}
